Name: bash
Version: 2.05b
Release: alt7

Summary: The GNU Bourne Again SHell (Bash)
Group: Shells
License: GPL
Packager: Bash Development Team <bash@packages.altlinux.org>

Source0: ftp://ftp.gnu.org/pub/gnu/%name-%version.tar.bz2
Source1: ftp://ftp.gnu.org/pub/gnu/%name-doc-%version.tar.bz2
Source2: ftp://ftp.cwru.edu/pub/bash/FAQ
Source3: bashrc
Source4: bash_alias

# bash205b-00{1,2,5,6,7} are purely for readline.
Patch1: ftp://ftp.cwru.edu/pub/bash/%name-%version-patches/bash205b-003
Patch2: ftp://ftp.cwru.edu/pub/bash/%name-%version-patches/bash205b-004

# http://www.caliban.org/bash/index.shtml#completion
#%name-2.05a-ian-service_completion.patch

Patch11: %name-2.05b-owl-alt-fixes.patch
Patch12: %name-2.05b-owl-alt-tmp.patch
Patch13: %name-2.05b-owl-alt-vitmp.patch

Patch21: %name-2.05b-alt-config.patch
Patch22: %name-2.05b-alt-winsize.patch
Patch23: %name-2.05b-alt-smatch-disable-strcoll.patch
Patch24: %name-2.05b-alt-man.patch
Patch25: %name-2.05b-alt-examples.patch
Patch26: %name-2.05b-alt-bashbug.patch

Patch31: %name-2.05b-rh-bash1_compat.patch
Patch32: %name-2.05b-rh-shellfunc.patch
Patch33: %name-2.05b-rh-alt-requires.patch
Patch34: %name-2.05b-rh-loadables.patch
Patch35: %name-2.05b-rh-mbinc.patch
Patch36: %name-2.05b-rh-restrict.patch

Patch41: %name-2.05b-deb-alt-random.patch
Patch42: %name-2.05b-deb-alt-man.patch
Patch43: %name-2.05b-deb-arrayfunc.patch
Patch44: %name-2.05b-deb-builtins-shift.dpatch

# bashbug produces a lot of unneeded dependencies.
AutoReq: yes, noshell

Requires: sh = %version-%release
Provides: bash2 = %version-%release
Obsoletes: bash2

BuildPreReq: libreadline-devel >= 4.3, mktemp >= 1:1.3.1

# Automatically added by buildreq on Sat Jun 29 2002
BuildRequires: libreadline-devel libtinfo-devel

%package -n sh
Summary: The GNU Bourne Again SHell (/bin/sh)
Group: Shells
Provides: /bin/sh
Conflicts: %name < %version-%release
AutoReq: yes

%package doc
Group: Shells
Summary: Documentation for the GNU Bourne Again SHell
Requires: %name = %version-%release
Obsoletes: bash2-doc
AutoReq: yes

%package examples
Group: Development/Other
Summary: Examples for the GNU Bourne Again SHell
Requires: %name = %version-%release
Obsoletes: bash2-examples
AutoReq: yes

%description
Bash is an sh-compatible command language interpreter that executes
commands read from the standard input or from a file.  Bash also
incorporates useful features from the Korn and C shells (ksh and csh).
Most sh scripts can be run by bash without modification.

Bash is ultimately intended to be a conformant implementation of the
IEEE POSIX Shell and Tools specification (IEEE Working Group 1003.2).

%description -n sh
Bash is an sh-compatible command language interpreter that executes
commands read from the standard input or from a file.  Bash also
incorporates useful features from the Korn and C shells (ksh and csh).
Most sh scripts can be run by bash without modification.

Bash is ultimately intended to be a conformant implementation of the
IEEE POSIX Shell and Tools specification (IEEE Working Group 1003.2).

This package contains /bin/sh.

%description doc
Bash is an sh-compatible command language interpreter that executes
commands read from the standard input or from a file.  Bash also
incorporates useful features from the Korn and C shells (ksh and csh).
Most sh scripts can be run by bash without modification.

Bash is ultimately intended to be a conformant implementation of the
IEEE POSIX Shell and Tools specification (IEEE Working Group 1003.2).

This package contains documentation for the GNU Bourne Again SHell.

%description examples
Bash is an sh-compatible command language interpreter that executes
commands read from the standard input or from a file.  Bash also
incorporates useful features from the Korn and C shells (ksh and csh).
Most sh scripts can be run by bash without modification.

Bash is ultimately intended to be a conformant implementation of the
IEEE POSIX Shell and Tools specification (IEEE Working Group 1003.2).

This package contains examples for the GNU Bourne Again SHell.

%prep
%setup -q -a1
%__rm -f configure
rm -f y.tab.?
rm -f doc/*.info*
install -p -m755 /usr/bin/texi2dvi support/

install -p -m644 %SOURCE2 doc/

# CWRU
%patch1 -p0
%patch2 -p0

# Owl
%patch11 -p1
%patch12 -p1
%patch13 -p1

# ALT
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1

# RH
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1

# DEB
%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch44 -p1

find -type f -name \*.orig -print -delete

echo %version >_distribution
echo %release |sed -e 's/alt\(.\+\).*/\1/' >_patchlevel

# Would anyone volunteer to fix those? Probably not.
find examples -type f -print0 |
	xargs -r0 %__grep -FlZ -- /tmp |
	xargs -r0 %__rm -fv --

%build
export \
	bash_cv_dev_fd=standard \
	bash_cv_dev_stdin=present \
	bash_cv_mail_dir=/var/mail \
	bash_cv_termcap_lib=libtinfo \
	%{?__buildreqs:bash_cv_must_reinstall_sighandlers=no} \
	#

autoconf

# Build sh.
%configure \
	--disable-bang-history \
	--disable-command-timing \
	--disable-history \
	--disable-net-redirections \
	--disable-progcomp \
	--disable-readline \
	--disable-restricted \
	--disable-help-builtin \
	#
# SMP-incompatible build.
%make
%__mv %name sh
%make clean

# Build bash.
%configure \
	--with-installed-readline \
	--disable-command-timing \
	--disable-net-redirections \
	--enable-separate-helpfiles \
	#
# SMP-incompatible build.
%make

%install
%makeinstall

%__install -pD -m755 sh $RPM_BUILD_ROOT/bin/sh
%__mv $RPM_BUILD_ROOT%_bindir/%name $RPM_BUILD_ROOT/bin/%name
%__ln_s %name $RPM_BUILD_ROOT/bin/bash2

# Make manpages for bash builtins as per suggestion in DOC/README.
pushd doc
	%__sed -e '
/^\.SH NAME/, /\\- bash built-in commands, see \\fBbash\\fR(1)$/{
/^\.SH NAME/d
s/^bash, //
s/\\- bash built-in commands, see \\fBbash\\fR(1)$//
s/,//g
b
}
d
' builtins.1 > man.pages
	for f in `cat man.pages` ; do
		%__ln_s builtins.1 "$RPM_BUILD_ROOT%_man1dir/$f.1"
	done
popd

# Those conflicts with real manpages.
%__rm -f $RPM_BUILD_ROOT%_man1dir/{echo,export,pwd,test,kill}.1

%__ln_s %name $RPM_BUILD_ROOT/bin/r%name
%__ln_s %name.1 $RPM_BUILD_ROOT%_man1dir/sh.1
%__ln_s %name.1 $RPM_BUILD_ROOT%_man1dir/bash2.1

%__install -pD -m755 $RPM_SOURCE_DIR/bash_alias $RPM_BUILD_ROOT%_sysconfdir/bashrc.d/alias.sh
%__install -p -m755 $RPM_SOURCE_DIR/bashrc $RPM_BUILD_ROOT%_sysconfdir/

# Remove unneeded makefiles.
find examples -type f -name 'Makefile*' -print0 |
	xargs -r0 %__rm -f --

# Prevent bogus dependencies.
find examples -type f -print0 |
	xargs -r0 %__chmod -x --

# Prepare documentation.
%__mkdir_p $RPM_BUILD_ROOT%_docdir/%name-%version/{html,ps,txt}
install -p -m644 \
	COMPAT NEWS CHANGES NOTES AUTHORS POSIX doc/{FAQ,INTRO} \
	$RPM_BUILD_ROOT%_docdir/%name-%version/
install -p -m644 doc/*.html $RPM_BUILD_ROOT%_docdir/%name-%version/html/
install -p -m644 doc/*.ps $RPM_BUILD_ROOT%_docdir/%name-%version/ps/
install -p -m644 doc/*.txt $RPM_BUILD_ROOT%_docdir/%name-%version/txt/
%__bzip2 -9 $RPM_BUILD_ROOT%_docdir/%name-%version/{[A-Z],{ps,txt}/}*
%__cp -a examples $RPM_BUILD_ROOT%_docdir/%name-%version/

%files -n sh
/bin/sh

%files
%config(noreplace) %_sysconfdir/bashrc*
/bin/*%{name}*
%_bindir/*
%_datadir/%name
%_mandir/man?/..?*
%_mandir/man?/*
%_infodir/*.info*
%dir %_docdir/%name-%version
%_docdir/%name-%version/[A-Z]*

%files doc
%dir %_docdir/%name-%version
%_docdir/%name-%version/html
%_docdir/%name-%version/ps
%_docdir/%name-%version/txt

%files examples
%dir %_docdir/%name-%version
%_docdir/%name-%version/examples

%changelog
* Fri Feb 11 2005 Dmitry V. Levin <ldv@altlinux.org> 2.05b-alt7
- %_sysconfdir/bashrc: updated PROMPT_COMMAND.
- Fixed build with gcc-3.4.x (closes #6082).

* Thu Oct 09 2003 Dmitry V. Levin <ldv@altlinux.org> 2.05b-alt6
- Fixed verbose shift with no argument (deb #159996).
- Better fix for rbash misbehaviour (rh #78455).
- Updated the Bash FAQ to version 3.26.
- Enhanced --rpm-requires support.

* Sun Apr 20 2003 Dmitry V. Levin <ldv@altlinux.org> 2.05b-alt5
- Fixed rh-alt-requires patch so it works with builtins again.
- %_sysconfdir/bashrc: added Eterm to the list of terminal names
  which support title change escape sequence (#0002410).

* Sat Dec 14 2002 Dmitry V. Levin <ldv@altlinux.org> 2.05b-alt4
- Updated the Bash FAQ to version 3.21.
- Fixed rbash misbehaviour, patch from Chet Ramey.
- jobs.c (initialize_job_control): always call get_tty_state().
- jobs.c (initialize_job_signals): always call set_sigwinch_handler().

* Thu Oct 17 2002 Dmitry V. Levin <ldv@altlinux.org> 2.05b-alt3
- Fixed bashbug script.

* Sun Sep 29 2002 Dmitry V. Levin <ldv@altlinux.org> 2.05b-alt2
- Applied two "official" patches from
  ftp://ftp.cwru.edu/pub/bash/bash-2.05b-patches/.

* Sun Sep 15 2002 Dmitry V. Levin <ldv@altlinux.org> 2.05b-alt1
- 2.05b:
  updated patches:
  + owl-alt-fixes
  + owl-alt-tmp
  merged upstream:
  + rh-mailcheck
  obsolete:
  + rh-kill_builtin
  + deb-gnusource
  + deb-arm
- Build sh with --disable-help-builtin.
- Build bash with --enable-separate-helpfiles.

* Sun Sep 15 2002 Dmitry V. Levin <ldv@altlinux.org> 2.05a-alt3
- Linked with readline-4.3.

* Sat Jun 29 2002 Dmitry V. Levin <ldv@altlinux.org> 2.05a-alt2
- Linked with libtinfo.

* Fri Jun 07 2002 Dmitry V. Levin <ldv@altlinux.org> 2.05a-alt1
- 2.05a, updated patches.
- Use texi2dvi from texinfo package for bash build.
- Default to vitmp in fc (the history editor) and bashbug script (Owl).
- Don't mishandle negative pid in `kill' builtin (rh).
- Fix for SEGV when some special shell variables are declared as array (deb).
- Added service completion (Ian Macdonald).
- Built with --disable-net-redirections (use netcat instead).
- Make non-interactive shells begun with argv[0][0] == '-'
  run the startup files when not in posix mode.
- Check whether shell being run by sshd and source the .bashrc
  if so (like the rshd behavior).
- bashbug: send bug reports also to ALT bash maintainer.
- Introduced %_sysconfdir/bashrc.d directory.
- bashrc: changed scripts load directory:
  %_sysconfdir/profile.d/ --> %_sysconfdir/bashrc.d/
  (upgrading to glibc >= 2.2.5-alt6 is recommended).
- alias.sh: reduced ammount of default aliases and relocated it
  from %_sysconfdir/profile.d/ to %_sysconfdir/bashrc.d/.

* Wed Mar 20 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.05-alt6
- Reenable job control for /bin/sh.

* Wed Mar 20 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.05-alt5
- Merged in Owl patches:
  + bash-2.05-owl-alt-fixes
  + bash-2.05-owl-tmp
- Merged in Debian patches:
  + bash-2.05-deb-64bit
  + bash-2.05-deb-gnusource
  + bash-2.05-deb-print_cmd
  + bash-2.05-deb-random
  + bash-2.05-deb-man
- Merged in RedHat patches:
  + bash-2.05a-rh-loadables.patch
  + bash-2.05a-rh-mailcheck.patch
- Fixed bashrc interactive shell detection.
- Fixed bashrc $f setting (#0000663).
- Fixed build without readline support.
- Build /bin/sh as outstanding package sh
  (without interactive features).

* Mon Aug 20 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.05-alt4
- Added explicit prereqs on shared libraries.
- Added IPv6 patch (from pld).
- Added some bugfix patches from the maintainer.
- Added rbash link.
- Updated semantic of aliases loading (from mdk).
- Relocated documentation.
- Removed "which" alias.

* Tue May 22 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.05-alt3
- Fixed tmpfile handling in bashbug script.

* Mon May 07 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.05-alt2
- Don't use strcoll(3) for range comparisons in bracket expressions,
  as in %name-2.04.

* Fri Apr 20 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.05-alt1
- 2.05

* Tue Dec 12 2000 Dmitry V. Levin <ldv@fandra.org> 2.04-ipl2mdk
- Added winsize patch; checkwinsize now enabled by default;
  added ROWS and COLUMNS dynamic variables.
- Moved examples to separate subpackage.

* Mon Oct 30 2000 Dmitry V. Levin <ldv@fandra.org> 2.04-ipl1mdk
- RE adaptions.
- FHSification.
- Merge patches from RH.

* Sun Jun 11 2000 Dmitry V. Levin <ldv@fandra.org>
- Merge with MDK.

* Wed Mar 22 2000 Dmitry V. Levin <ldv@fandra.org>
- 2.04

* Wed Sep 20 1999 Dmitry V. Levin <ldv@fandra.org>
- Fandra adaptions

* Sun Aug 22 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Remove the alias to ls colors in bash_alias (doble with fileutils scripts).

* Fri Aug 20 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Fix wrong group in doc package.
- Increase version ;).

* Fri Aug 20 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Fix wrong man links (#20).

* Fri Jul 23 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
  - Ken Estes <kestes@staff.mail.com>
    - patch to detect what executables are required by a script.

* Wed Jul 21 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Remove 'DarkTiti' hack.

* Fri Jul 16 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- Make the `echo' builtin expand backslash-escaped characters by default,
  without requiring the `-e' option.  This makes the Bash `echo' behave
  more like the System V version.

* Tue Jul 9 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- french description

* Tue Jul 8 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- compiled against local libreadline (which is not compiled in now)
  => reduce the size of bash by 42%.
  Moreover, a part of its memory is shared with other readline programs (bc, ...)
- disable built-in time command (incompatible with standard POSIX time command)

* Tue May 25 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- handle RPM_OPT_FLAGS

* Sat May 15 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- alias.sh fix with the new syntax of bash2.

* Tue May 11 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Fixing many stupid forget :-((

* Tue Apr 27 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Relifting of the doc-section.
- Moving the alias to a new files.

* Fri Apr  9 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- bzip2 man/info pages
- handle RPM_OPT_FLAGS
- add de locale
- add some aliases (ls=ls --color, md, rd, cd..) to bashrc
- fix download URLs
- make it compile if the release number contains non-digits
- We're NOT a %arch-redhat-linux

* Mon Feb 22 1999 Jeff Johnson <jbj@redhat.com>
- updated text in spec file.
- update to 2.03.

* Fri Feb 12 1999 Cristian Gafton <gafton@redhat.com>
- build it as bash2 instead of bash

* Tue Feb  9 1999 Bill Nottingham <notting@redhat.com>
- set 'NON_INTERACTIVE_LOGIN_SHELLS' so profile gets read

* Thu Jan 14 1999 Jeff Johnson <jbj@redhat.com>
- rename man pages in bash-doc to avoid packaging conflicts (#606).

* Wed Dec 02 1998 Cristian Gafton <gafton@redhat.com>
- patch for the arm
- use $RPM_ARCH-redhat-linux as the build target

* Tue Oct  6 1998 Bill Nottingham <notting@redhat.com>
- rewrite %pre, axe %postun (to avoid prereq loops)

* Wed Aug 19 1998 Jeff Johnson <jbj@redhat.com>
- resurrect for RH 6.0.

* Sun Jul 26 1998 Jeff Johnson <jbj@redhat.com>
- update to 2.02.1

* Thu Jun 11 1998 Jeff Johnson <jbj@redhat.com>
- Package for 5.2.

* Mon Apr 20 1998 Ian Macdonald <ianmacd@xs4all.nl>
- added POSIX.NOTES doc file
- some extraneous doc files removed
- minor .spec file changes

* Sun Apr 19 1998 Ian Macdonald <ianmacd@xs4all.nl>
- upgraded to version 2.02
- Alpha, MIPS & Sparc patches removed due to lack of test platforms
- glibc & signal patches no longer required
- added documentation subpackage (doc)

* Fri Nov 07 1997 Donnie Barnes <djb@redhat.com>
- added signal handling patch from Dean Gaudet <dgaudet@arctic.org> that
  is based on a change made in bash 2.0.  Should fix some early exit
  problems with suspends and fg.

* Mon Oct 20 1997 Donnie Barnes <djb@redhat.com>
- added %clean

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- added comment explaining why install-info isn't used
- added mips patch

* Fri Oct 17 1997 Donnie Barnes <djb@redhat.com>
- added BuildRoot

* Tue Jun 03 1997 Erik Troan <ewt@redhat.com>
- built against glibc
